<?php

/*
 * Plugin Name: LastEntries
 * Version: 1.0
 * Type: Block
 * Plugin URI: https://www.flatpress.org
 * Author: FlatPress
 * Author URI: https://www.flatpress.org
 * Description: Adds a widget that lists the latest entries. Part of the standard distribution.
 */
function plugin_lastentries_widget() {
	global $fpdb;

	// load plugin strings
	// they're located under plugin.PLUGINNAME/lang/LANGID/
	$lang = lang_load('plugin:lastentries');

	$num = 10;
	// ###################

	/*
	 * $queryId = $fpdb->query("fullparse:false,start:0,count:$num");
	 * $fpdb->doquery($queryId);
	 *
	 * $fpdb->getQuery
	 */

	$q = new FPDB_Query(array(
		'fullparse' => false,
		'start' => 0,
		'count' => $num
	), null);

	$string = '<ul>';

	$count = 0;

	while ($q->hasmore()) {

		list ($id, $entry) = $q->getEntry();

		$link = get_permalink($id);

		$string .= '<li>';
		$admin = BLOG_BASEURL . "admin.php?p=entry&amp;entry=";
		if (user_loggedin()) // if loggedin prints a "edit" link
			$string .= "<a href=\"{$admin}{$id}\">[" . $lang ['plugin'] ['lastentries'] ['edit'] . "]</a>";
		$string .= "<a href=\"{$link}\">{$entry['subject']}</a></li>\n";

		$count++;
	}

	if ($string == '<ul>') {
		$string .= '<li><a href="admin.php?p=entry&amp;action=write">' . $lang ['plugin'] ['lastentries'] ['add_entry'] . '</a></li>';
		$subject = $lang ['plugin'] ['lastentries'] ['no_entries'];
	} else
		$subject = $lang ['plugin'] ['lastentries'] ['subject_before_count'] . $count . $lang ['plugin'] ['lastentries'] ['subject_after_count'];

	$string .= '</ul>';

	$widget = array();
	$widget ['subject'] = $subject;
	$widget ['content'] = $string;

	return $widget;
}

register_widget('lastentries', 'LastEntries', 'plugin_lastentries_widget');


// this will tell FlatPress to load the new tags at the very beginning 
add_filter('init', 'plugin_lastentries_tags');

function plugin_lastentries_tags() {
    $bbcode = plugin_bbcode_init(); //import the "global" bbcode object into current function
                                    // this way 
                                    // a) parsing is done only once, and by the official plugin
                                    // b) you create only ONE object, and therefore computation is quicker

    $bbcode->addCode (
        'lastentries',  // tag name: this will go between square brackets
        'callback_replace', // type of action: we'll use a callback function
        'plugin_custombbcode_lastentries', // name of the callback function
        array('usecontent_param' => array ('default')), // supported parameters: "default" is [acronym=valore]
        'inline', // type of the tag, inline or block, etc
        array ('listitem', 'block', 'inline', 'link'), // type of elements in which you can use this tag
        array ()); // type of elements where this tag CAN'T go (in this case, none, so it can go everywhere)
    $bbcode->setCodeFlag ('lastentries', 'closetag', BBCODE_CLOSETAG_FORBIDDEN); // a closing tag must exist [/tag]

}

function plugin_custombbcode_lastentries($action, $attributes, $content, $params, $node_object) { 
    if ($action == 'validate') {
       // not used for now
       return true;
    }

    $widget = plugin_lastentries_widget();
    return $widget['content'];
    
}

?>
